#include <stdio.h>
#include "ableos_std/ableos_std.c"

typedef enum {
    // KeyUp is the default state
    KeyUp = 0,
    KeyDown = 0x43,
} KeyState;

typedef struct {
    KeyState kstate;
    // TODO: https://github.com/rust-windowing/winit/issues/2995
    char key;
} KeyboardEvent;


void send_keyb_event_ipc(KeyboardEvent kevent){

}



KeyboardEvent get_keyboard_event(){
    /*
    li64(r1, 5);
    li64(r2, 0x64);
    eca();
    */

    return (KeyboardEvent) {
        .kstate = KeyUp,
        .key = 'c' 
    };

}

typedef enum {
    ScanCodeSet1 = 0x43,
    ScanCodeSet2 = 0x41,
    ScanCodeSet3 = 0x3f,
    
    ACK = 0xFA,
    Resend = 0xFE,
} PS2Response;

typedef enum {
    GetCurrent = 0,
    CommandScanCodeSet1 = 1,
    CommandScanCodeSet2 = 2,
    CommandScanCodeSet3 = 3,
} PS2ScancodeSet;


PS2Response set_led() {
    return Resend;
}

PS2Response scancode_command(PS2ScancodeSet scancode) {
    return  Resend;
}

// Replacement for the PS/2 Keyboard Driver on ableOS 
int main() {
    Argument args = get_arguments();

    MTRand a = mersenne_twister_seed_rand(10);
    f64 ac = mt_generate_f64_0_to_1(&a);
    printf("%f\n\r", ac);

    int b = string_eq(args.value, from_c_str("x86-64"));
    if (b == 1) {
        info("running on X86");
    } else {
        error("This driver cannot run on non-x86_64 machines");
        // terminate_process();
    }

    info("abc");
    bool running = false;
    while (running) {
        // check incoming buffer for keyb settings changes
        bool changes = false;
        // if they exist apply changes 
        if (changes) {
            set_led();
        }
        // check keyb state
        get_keyboard_event();
        // push keyb state to a buffer
    }
    
    create_process();


    return 0;
};

